<?php

/**

*

* @package Board3 Portal v2.1+ - Recent Active topics V0.0.1

* @copyright (c) Board3 Group ( www.board3.de )

* @license http://opensource.org/licenses/gpl-license.php GNU Public License

* @Recent Active topics V0.0.1 by Talonos @ http://pretereo-stormrage.co.uk

*/



namespace talonos\b3precentactivetopic;

/**

* @package b3precentactivetopic

*/

class b3precentactivetopiccenter extends \board3\portal\modules\module_base

{

	/**

	* Allowed columns: Just sum up your options (Exp: left + right = 10)

	* top		1

	* left		2

	* center	4

	* right		8

	* bottom	16

	*/

	public $columns = 4;



	/**

	* Default b3precentactivetopic

	*/

	public $name = 'RECENT_ACTIVE_CEN';



	/**

	* Default module-image:

	* file must be in "{T_THEME_PATH}/images/portal/"

	*/

	public $image_src = '';



	/**

	* module-language file

	* file must be in "language/{$user->lang}/mods/portal/"

	*/

	    public $language = array(

        'vendor'    => 'talonos/b3precentactivetopic',

        'file'        => 'common',

    );

	



	/** @var \phpbb\config\config */

	protected $config;



	/** @var \phpbb\controller\helper */

	protected $helper;



	/** @var \phpbb\template\template */

	protected $template;



	/** @var \phpbb\user */

	protected $user;



	/** @var \phpbb\auth\auth */

	protected $auth;



	/** @var \phpbb\db\driver\driver_interface */

	protected $db;



	/** @var \phpbb\cache\service */

	protected $cache;



	protected $phpbb_root_path;

	protected $phpEx;



    /**

     * Constructor for clock module

     *

     * @param \phpbb\config\config $config phpBB config

     * @param \phpbb\template\template $template phpBB template

     */

	public function __construct(\phpbb\config\config $config, \phpbb\controller\helper $helper, \phpbb\template\template $template, \phpbb\user $user, \phpbb\auth\auth $auth, \phpbb\db\driver\driver_interface $db, \phpbb\cache\service $cache, $phpbb_root_path, $phpEx, \phpbb\collapsiblecategories\operator\operator $operator = null)

	{

		$this->config = $config;

		$this->helper = $helper;

		$this->template = $template;

		$this->user = $user;

		$this->auth = $auth;

		$this->db = $db;

		$this->cache = $cache;

		$this->phpbb_root_path = $phpbb_root_path;

		$this->phpEx = $phpEx;
		
		$this->operator = $operator;

	}



	public function get_template_center($module_id)

	{

	

	$fflist = $this->auth->acl_getf('f_read', true);

	$fflist = array_unique(array_keys($fflist));

	$fflist = array_merge($fflist, array(0));



	// Recent Active Topics

	$cenenable_active_topics = (!empty($this->config['b3pcen_tsrat_enable_' . $module_id]) ? true : false);

	if ($cenenable_active_topics && sizeof($fflist))

	{

	$sqlcen = 'SELECT t.forum_id, t.topic_id, t.topic_title, t.topic_time, t.topic_views, t.topic_poster,	t.topic_posts_approved, t.topic_first_poster_name, t.topic_first_poster_colour, t.topic_last_post_id, t.topic_last_poster_name, t.topic_last_poster_colour, t.topic_last_post_time, t.topic_last_view_time, t.topic_last_poster_id, f.forum_name, f.forum_image

		FROM ' . TOPICS_TABLE . ' t

		LEFT JOIN ' . FORUMS_TABLE . ' f ON (t.forum_id = f.forum_id)

		WHERE ' . $this->db->sql_in_set('t.forum_id', $fflist) . ' AND t.topic_moved_id = 0

		ORDER BY t.topic_last_post_time DESC';

	$resultt = $this->db->sql_query_limit($sqlcen, $this->config['b3pcen_tsrat_number']);



	while ($roww = $this->db->sql_fetchrow($resultt))

	{

		$cenview_topic_url = append_sid("{$this->phpbb_root_path}viewtopic.$this->phpEx", 'f=' . $roww['forum_id'] . '&amp;t=' . $roww['topic_id']);

		$cenview_last_post_url = append_sid("{$this->phpbb_root_path}viewtopic.$this->phpEx", 'f=' . $roww['forum_id'] . '&amp;p=' . $roww['topic_last_post_id'] . '#p' . $roww['topic_last_post_id']);

		$cenview_first_poster = append_sid("{$this->phpbb_root_path}memberlist.$this->phpEx", 'mode=viewprofile' . '&amp;u=' . $roww['topic_poster']);

		$cenview_last_poster = append_sid("{$this->phpbb_root_path}memberlist.$this->phpEx", 'mode=viewprofile' . '&amp;u=' . $roww['topic_last_poster_id']);

		$cenview_viewforum_url = append_sid("{$this->phpbb_root_path}viewforum.$this->phpEx", 'f=' . $roww['forum_id']);


	if ($this->operator !== null)
{
    $fid = 'B3PRECENTCEN_1'; // can be any unique string to identify your extension's collapsible element
    $this->template->assign_vars(array(
        'S_B3PRECENTCEN_HIDDEN' => in_array($fid, $this->operator->get_user_categories()),
        'U_B3PRECENTCEN_COLLAPSE_URL' => $this->helper->route('phpbb_collapsiblecategories_main_controller', array(
            'forum_id' => $fid,
            'hash' => generate_link_hash("collapsible_$fid")))
    ));
}
		$this->template->assign_block_vars('recent_activecen', array(

			'TOPIC_TITLE'					=> $roww['topic_title'],

			'TOPIC_TIME'					=> $this->user->format_date($roww['topic_time']),

			'TOPIC_VIEWS'					=> $roww['topic_views'],

			'TOPIC_REPLIES'					=> $roww['topic_posts_approved'],

			'TOPIC_FIRST_POSTER_NAME'		=> $roww['topic_first_poster_name'],

			'TOPIC_FIRST_POSTER_COLOUR'		=> $roww['topic_first_poster_colour'],

			'TOPIC_LAST_POSTER_NAME'		=> $roww['topic_last_poster_name'],

			'TOPIC_LAST_POSTER_COLOUR'		=> $roww['topic_last_poster_colour'],

			'TOPIC_LAST_POST_TIME'			=> $this->user->format_date($roww['topic_last_post_time']),

			'TOPIC_LAST_VIEW_TIME'			=> $this->user->format_date($roww['topic_last_view_time']),

			'U_FIRST_TOPIC'					=> $cenview_topic_url,

			'U_LAST_TOPIC'					=> $cenview_last_post_url,

			'USERNAME_FIRST'				=> $cenview_first_poster,

			'USERNAME_LAST'					=> $cenview_last_poster,

			'FORUM_NAME'					=> $roww['forum_name'],

			'FORUM_IMAGE'					=> $roww['forum_image'],

			'FORUM_URL'						=> $cenview_viewforum_url,

		));

	}

	$this->db->sql_freeresult($resultt);

	

		$this->template->assign_vars(array(

			'B3PCEN_S_TSRAT_ENABLE'		=> ($this->config['b3pcen_tsrat_enable_' . $module_id]) ? true : false,

			'B3PCEN_TSRAT_NUMBER'	=> $this->config['b3pcen_tsrat_number'],

			'B3PCEN_S_JSSCROLLER'		=> ($this->config['b3pcen_ts_jsscroller_' . $module_id]) ? true : false,

			'B3PCEN_JSSCROLL_SPEED'		=> $this->config['b3pcen_tsjss_speed_' . $module_id],

			'B3PCEN_JSSCROLL_INTERVAL'		=> $this->config['b3pcen_tsjss_interval_' . $module_id],

			'B3PCEN_TS_JSSCROLL_DIRECTION'		=> ($this->config['b3pcen_ts_jsscroll_direction_' . $module_id]) ? true : false,

			'B3PCEN_TS_JSSCROLL_PAUSE'		=> ($this->config['b3pcen_ts_jsscroll_pause_' . $module_id]) ? true : false,

			'B3PCEN_TS_JSSCROLL_NAVIGATION'		=> ($this->config['b3pcen_ts_jsscroll_navigation_' . $module_id]) ? true : false,

		));



		return '@talonos_b3precentactivetopic/b3precentcenter.html';

	}

}

	public function get_template_acp($module_id)

   {

      return array(

         'title'   => 'RECENT_ACTIVE_CEN',

         'vars'   => array(

			// settings

			'legend1'                     => 'RECENT_ACTIVE_CEN',

				'b3pcen_tsrat_number'					=> array('lang' => 'TSRAT_NUMBER',		'validate' => 'string',	'type' => 'text:6:6',	'explain' => true),

				'b3pcen_ts_jsscroller_' . $module_id		=> array('lang' => 'TS_JSSCROLL',		'validate' => 'string',	'type' => 'radio:yes_no',	'explain' => true),

				'b3pcen_tsjss_speed_' . $module_id		=> array('lang' => 'TS_JSSCROLL_SPEED',	'validate' => 'string', 'type' => 'text:6:6',	'explain' => true),

				'b3pcen_tsjss_interval_' . $module_id		=> array('lang' => 'TS_JSSCROLL_INTERVAL',	'validate' => 'string', 'type' => 'text:6:6',	'explain' => true),

				'b3pcen_ts_jsscroll_direction_' . $module_id		=> array('lang' => 'TS_JSSCROLL_DIRECTION',	'validate' => 'string', 	'type' => 'custom',	'explain' => true,	'method' => 'select_direction', 'submit' => 'store_direction'),

				'b3pcen_ts_jsscroll_pause_' . $module_id		=> array('lang' => 'TS_JSSCROLL_PAUSE',		'validate' => 'string',	'type' => 'radio:yes_no',	'explain' => true),

				'b3pcen_ts_jsscroll_navigation_' . $module_id		=> array('lang' => 'TS_JSSCROLL_NAVIGATION',	'validate' => 'string', 'type' => 'radio:yes_no',	'explain' => true),

				)

      );

   }



   	public function select_direction($value, $key, $module_id)

	{

		global $db, $cache;



		$ext_options = '<select id="' . $key . '" name="' . $key . '[]">';

		

		if ($value == '1') {$ext_options .= '<option value="1" selected="selected">Up</option>';}

		else {$ext_options .= '<option value="1">Up</option>';}

		if ($value == '0') {$ext_options .= '<option value="0" selected="selected">Down</option>';}

		else {$ext_options .= '<option value="0">Down</option>';}

		$ext_options .= '</select>';

		

		return $ext_options;



	}

	public function store_direction($key, $module_id)

	{

		global $db, $cache;

		

		// Get selected extensions

		$values = request_var($key, array(0 => ''));

		$valuess = implode(',', $values);

		set_config($key, $valuess);



	}

	/**

	* API functions

	*/

	public function install($module_id)

	{

		$this->config->set('b3pcen_tsrat_enable_' . $module_id, 1);

		$this->config->set('b3pcen_tsrat_number', 5);

		$this->config->set('b3pcen_ts_jsscroller_' . $module_id, 1);

		$this->config->set('b3pcen_tsjss_speed_' . $module_id, 400);

		$this->config->set('b3pcen_tsjss_interval_' . $module_id, 4000);

		$this->config->set('b3pcen_ts_jsscroll_direction_' . $module_id, 1);

		$this->config->set('b3pcen_ts_jsscroll_pause_' . $module_id, 1);

		$this->config->set('b3pcen_ts_jsscroll_navigation_' . $module_id, 1);

		return true;

	}



	public function uninstall($module_id, $db)

	{

		$this->config->delete('b3pcen_tsrat_enable_' . $module_id);

		$this->config->delete('b3pcen_tsrat_number');

		$this->config->delete('b3pcen_ts_jsscroller_' . $module_id);

		$this->config->delete('b3pcen_tsjss_speed_' . $module_id);

		$this->config->delete('b3pcen_tsjss_interval_' . $module_id);

		$this->config->delete('b3pcen_ts_jsscroll_direction_' . $module_id);

		$this->config->delete('b3pcen_ts_jsscroll_pause_' . $module_id);

		$this->config->delete('b3pcen_ts_jsscroll_navigation_' . $module_id);



		return true;

	}

}

